Index: tag/rc-1/faye_awasemou/sp4a12/sp4a12/main.c
===================================================================
--- tag/rc-1/faye_awasemou/sp4a12/sp4a12/main.c	(nonexistent)
+++ tag/rc-1/faye_awasemou/sp4a12/sp4a12/main.c	(revision 492)
@@ -0,0 +1,379 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
+
+
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+        0};
+            //declaration de la structure position contenant la latitude et la longitude
+typedef struct {
+float latitude;
+float longitude;
+} Position ;
+
+// declaration d'une stucture permettant de decrire une zone renseignant la position et la vitesse limite associée
+typedef struct {
+    Position rpos;
+    float vitmax;
+ } Zone ;
+
+//création d'une table de zone dangereuse
+Zone zones[] = {
+ {{44.7887762, -3.012}, 50}, /* Descripteur de la première zone */
+ {{44.7891220, -3,013}, 70},
+ {{45.7891220, 3,013}, 90},
+
+
+};
+        //fonction qui permet de savoir si la trame commence par la chaine de caractere type(GPGGA)
+int trame_cmp(char* trame, char* type) //prise en paramete de la trame envoyée et du type
+{
+    int i;//variable permettant de faire l'iteration du tableau de caractere trame et type(on parcoure l'intégralité du tableau)
+    int ok;//variable qui permet de retourner si la trame commence par le bon format(cad GPGGA) ou non
+    ok=0|1;
+    for (i=0;i<4;i++)// on tient en compte des 5 caracteres du debut de la trame car ce sont eux qui permettent de caractériser le bon format de la trame
+    {
+         if (trame[i+1]==type[i])//on compare la trame recu et le type (GPGGA) en ignorant le caractere $ du debut de la trame
+         {
+             ok=1; //ok prend la valeur 1 si la trame commence par le bon format 0 sinon
+
+         }else
+         {
+           ok=0; //0 sinon
+         }
+}
+return ok;// on retourne resultat de ok pour connaitre si la trame a le bon format ou non(je dis le bon format car ici ce sont les trames commencant par GPGGA qui nous interessent)
+}
+
+
+//fonction qui permet de renvoyer la valeur décimale associée à un caractère donné en paramètre
+
+int decode_int(char c) //prise en parametre d'un caractere c
+{
+    int Vdecimal; //valeur en decimal du caractere passé en parametre
+    if ( c <= '9' && c >='0' ) //comparaison pour savoir si le parametre recu est compris entre 0 et 9
+    {
+        Vdecimal =c-48; // si oui affectation(methode permettant de donner la valeur en decimal du caractere)
+
+
+    }else
+     {
+        Vdecimal=-1; //si le caractere passé en parametre n'est pas compris entre 0 et9 on renvoie -1
+
+    }
+    return Vdecimal; //on retourne la valeur decimal du caractere
+}
+
+    //fonction qui permet  de renvoyer la valeur décimale des n premiers caractères de la chaîne ch
+int decode_nombre(char* ch, int n )
+{
+    int i,s=0;  //i=variable permettant de faire l'iteration du tableau de caractere ch(on parcoure tout le tableau en incrementant la valeur de i qui est initialisé a 0 pour un tableau)
+    //s variable somme initialisée a 0 permettant de recuperer le nombre n de caractere qu'on veut recuperer sur une chaine de caractere ch
+    for(i=0;i<n;i++)//la boucle est executée de 0 a n fois
+    {
+        s=s*10 + decode_int(ch[i]);// on fait la somme des valeurs decimales apres avoir calculer la valeur décimale associée au caractère en utilisant la fonction decode_int
+
+    }
+    return s;// on retourne la somme;
+}
+
+
+// fonction qui convertit la latitude en un nombre flottant
+float conversionLatitude(char* latitude)
+{
+    //exemple latitude=3723.2475--> 37valDegre, 23Min_Entiere, (0.2475=2475*0.0001)2475MinDecimal donc 37,387458=37+(23+2475*0.0001)/60
+    int valDegre,MinEntiere,MinDecimal; //declaration des variables permettant de recuperer les valeurs en degre,minutes entieres et minutes decimales de la latitude
+    float resultatConversion ;
+    valDegre=decode_nombre(latitude,2);             //recuperer la valeur degre  de la latitude
+    MinEntiere=decode_nombre(&latitude[2],2);      //recuperer la valeur minute entiere de la latitude
+    MinDecimal=decode_nombre(&latitude[5],4);         //recuperer la valeur minute decimal de la latitude
+    resultatConversion=valDegre+((MinEntiere+MinDecimal*0.0001)/60);// operation de calcul du resultat du conversion de la latitude en valeur reelle
+    return resultatConversion;//on renvoie la valeur du resultat de la convertion
+}
+
+
+
+
+// fonction qui convertit la longitude en un nombre flottant
+float conversionLongitude(char* longitude)
+{
+    //exemple longitude =00306.6036,E signifie 3valDegre 06=MinEntiere , MinDecimal=6036' de longitude Est, soit 3,11006°
+    int valDegre, MinEntiere,MinDecimal;     //declaration des variables permettant de recuperer les valeurs en degre,minutes entieres et minutes decimales de la longitude
+    float resultatConversion;
+    valDegre=decode_nombre(longitude,3);             //recuperer la valeur degre  de la longitude
+    MinEntiere=decode_nombre(&longitude[3],2);      //recuperer la valeur minute entiere de la longitude
+    MinDecimal=decode_nombre(&longitude[6],4);         //recuperer la valeur minute decimal de la longitude
+    resultatConversion=valDegre +((MinEntiere+MinDecimal*0.0001)/60);// resultat de la conversion de la longitude en valeur reelle
+    return resultatConversion;//on renvoie la valeur du resultat de la convertion
+}
+
+ // fonction qui convertit la latitude ou la longitude en flottant
+float fonctionGenerique(char* chaine)
+{
+float resultatConversion; // resultat de la conversion de la longitude ou la latitude en valeur reelle
+    if(chaine[4]=='.')  //comparaison pour connaitre si la 4ieme variable de la chaine est un point comme le montre cet exemple 3723.2475
+     {
+         resultatConversion=conversionLatitude(chaine);// appel de la fonction qui permet de faire la conversion en flottant de la latitute; le resultat de la conversion est mis dans la variable resutatConversion
+     }
+    else
+        if(chaine[5]=='.') //comparaison pour connaitre si la 5ieme variable de la chaine est un point comme le montre cet exemple 00306.6036
+        {
+            resultatConversion=conversionLongitude(chaine);// appel de la fonction qui permet de faire la conversion en flottant de la longitute; le resultat de la conversion est mis dans la variable resutatConversion
+        }
+
+    return resultatConversion;//on renvoie la valeur du resultat de la convertion de la latitude ou de la longitude
+}
+
+
+// fonction qui permet de savoir si les trames sont au bon format "GPGGA" en renvoyant 1 et d'afficher la position cad la latitude et la longitude
+int decode_trame(char* trame,Position * position)
+{
+    //exempletrame="$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+    if (trame_cmp(trame,"GPGGA"))  //on utilise la fonction trame_cmp pour savoir si la trame a le bon format GPGGA
+    {
+        int i;
+        char ch[10];// tableau dans lequel on stocke la longitude de la trame
+        for (i=0;i<10;i++) ch[i]=trame[29+i];// on recupere la valeur de la longitude et on le met dans le tableau ch
+            position->latitude=conversionLatitude(trame+17);//on fait la conversion de la latitude apres avoir recuperer la latitude
+            position->longitude=conversionLongitude(ch);//on fait la conversion de la longitude
+        return 1;//on retourne 1 pour montrer qu'on a la trame type GPGGA et qu'on a recuperé la position en latitude et longitude
+    }
+     return 0;//on retourne 0 sinon, la trame est ignorée
+}
+//fonction qui permet de calculer la distance en deux points P1 et P2 en connaissant leurs latitudes et longitudes
+float calcul_distance(Position P1, Position P2)
+{
+    float distance;//variable contenant la distance calculée entre ces deux points
+    distance=(40000/360)*sqrt((P2.latitude-P1.latitude)*(P2.latitude-P1.latitude)+ (P2.longitude-P1.longitude)*(P2.longitude-P1.longitude));//40000(perimetre de la terre)/360(degré)=111km ->1°=111km sur terre
+    return distance; //on revoie la valeur du la distance calculée
+
+}
+
+//fonction qui calcule la vitesse correspondant au parcours de la distance entre deux points P1 et P2
+float calcul_vitesse(Position P1, Position P2)// on prend en parametre les positions des deux points en latitude et longitude
+{
+    float vitesse;//Variable contenant la vitesse resultante entre les deux points
+    vitesse=3600*calcul_distance(P1,P2);//on affecte a la vitesse la methode de calcul correspondante cad vitesse =distance /temps en faisant appel a la fonction calcul_distance sachant que le temps c'est 1s on a directement la vitesse en km/s donc on miltiplie par 3600 pour avoir la vitesse km/heure vu que 1h=3600s
+
+    return vitesse; //on revoie la valeur du la vistesse calculée
+}
+
+
+//fonction qui calcule la distance à la plus proche zone
+int distance_a_la_proche_zone(Position p, Zone r[],int nb_zones, float *d)
+{
+    float diCalculee;// variables contenant la valeur de la distance calculee entre la position courante et l element[i] du tableau de zones dangereuses
+    int i, index=0;//i=variable pour parcourir tout le tableau de zones et index=i qui minimise le tableau de zones par rapport a la distance calculee, elle correspond a la valeur de i pour laquelle on se situe a la zone la plus proche
+    *d=calcul_distance(p,r[0].rpos);//on calcule la distance entre la position courante du vehicule et le premier element du tableau de zones dangereuses
+       if(nb_zones>0)
+       {
+           for (i=1;i<nb_zones;i++)// on parcoure le tableau de zones de 1 a la valeurs maximales de zones
+            {
+            diCalculee=calcul_distance(p,r[i].rpos);//on calcule la distance entre la position courante du vehicule et l'element[i] du tableau de zones dangereuses
+                if(*d>diCalculee) //si la distance calculée a partir du 1ere element du tableau est superieur a la distance calculee avec lelement dindice i du table
+                {
+                   *d=diCalculee;// alors on affecte a la variable d la nouvelle distance la plus proche des zones dangereuses
+                    index=i;//a index on affecte la valeur de i qui minimise le tableau
+
+                }
+            }
+            return index;
+       }
+        return -1;// on retourne -1 si la table est vide
+
+}
+
+
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+static int cpt=0;
+    cpt++;
+
+Position p;
+Position p_initiale; // on declare une position a laquelle on initialise la latitude et la longitude avec des valeurs
+p_initiale.latitude=45.750403;
+p_initiale.longitude= 3.110065;
+float distance; //distance a laquelle se trouve le vehicule
+float vitesse;
+float seuil=710;//seuil que le distance du vehicule ne doit pas depasser
+int index;
+if (decode_trame(trame,&p)) // on regarde si la trame est valide
+    {
+        printf ("> %s\n",trame);// on affiche la trame recue
+        vitesse=calcul_vitesse(p_initiale,p);//on calcule la vitesse entre la position du vehicule et une position premiere d'une zone dangereuse
+        index=distance_a_la_proche_zone(p,zones,sizeof(zones),&distance);// on calcule la distance la plus proche pour trouver l'index
+        if ((distance<seuil) && (vitesse>zones[index].vitmax))// on compare si la distance est inferieur au seuil donne et si la vitesse est superieur a celle definie pour cette zone
+            {
+                //si cest cas on affiche la  distance et la vistance puis on declenche une alarme
+
+                printf(" La vitesse est egale a %f\n ",vitesse);
+                printf("La distance est egale a %f \n ",distance);
+                printf("Alarme ON \n");
+                printf(" Zone numero %d \n ",index);
+            }
+        else
+            //sinon l'alarme reste eteinte
+            printf("Alarme OFF \n ");
+            p_initiale = p;// on affecte a la position initiale la nouvelle position du vehicule car plus le vehicule roule plus il s'approche des zones dangereuses
+    }
+
+    return 0;
+}
+
+
+
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void)
+{
+     //variables concernant les tests unitaires calcul_vitesse et calcul_distance
+    Position  P1={45.75040333,3.110065};
+    Position P2={45.7500,3.11006};
+     //variable concernant le test unitaire  decode_trame
+    Position * position;
+    //variables concernant le test unitaire distance_a_la_proche_zone
+    int nb_zones=3;
+    float d;
+        //test unutaire basique
+        if (5!=5){
+            printf ("Erreur Test unitaire basique.\n");
+            exit(-1);
+            }
+
+            //tests unutaires de la fonction trame_cmp
+        if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+            printf ("Erreur Test unitaire trame_cmp.\n");
+            exit(-1);
+            }
+        if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+             printf ("Erreur Test unitaire trame_cmp.\n");
+             exit(-1);
+            }
+        if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+             printf ("Erreur Test unitaire trame_cmp.\n");
+             exit(-1);
+            }
+        if (trame_cmp("$APRMC...", "GPGGA")!=0){
+             printf ("Erreur Test unitaire trame_cmp.\n");
+             exit(-1);
+            }
+            //tests unutaires de la fonction decode_int
+
+        if (decode_int('0')!=0){
+             printf ("Erreur Test unitaire decode_int.\n");
+             exit(-1);
+            }
+        if (decode_int('7')!=7){
+             printf ("Erreur Test unitaire decode_int.\n");
+             exit(-1);
+            }
+        if (decode_int('A')!=-1){
+             printf ("Erreur Test unitaire decode_int.\n");
+             exit(-1);
+            }
+
+              //tests unutaires de la fonction decode_nombre
+
+        if (decode_nombre("7541",2)!=75){
+             printf ("Erreur Test unitaire decode_nombre.\n");
+             exit(-1);
+            }
+        if (decode_nombre("7541",3)!=754){
+             printf ("Erreur Test unitaire decode_nombre.\n");
+             exit(-1);
+            }
+
+              //tests unutaires de la fonction conversionLatitude
+
+        if (conversionLatitude("3723.2475")-37.38745833 > 0.0001){
+             printf ("Erreur Test unitaire conversion Latitude.\n");
+             exit(-1);
+            }
+
+        if (conversionLatitude("4545.0000")-45.7500 > 0.0001){
+             printf ("Erreur Test unitaire conversion Latitude.\n");
+             exit(-1);
+            }
+
+              //tests unutaires de la fonction conversionLongitude
+
+        if (conversionLongitude("00306.6039")- 3.110065 > 0.0001){
+             printf ("Erreur Test unitaire conversion Longitude.\n");
+             exit(-1);
+            }
+
+        if (conversionLongitude("00306.6036")- 3.11006 > 0.0001){
+             printf ("Erreur Test unitaire conversion Longitude.\n");
+             exit(-1);
+            }
+             //tests unutaires de la fonction decode_trame
+    if(decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",&position)!=1){
+            printf("Erreur Test decode trame \n");
+            exit(-1);
+            }
+
+
+
+            //tests unutaires de la fonction calcul_distance
+        if (calcul_distance(P1,P2)- 0.04481788787 > 0.001){
+            printf ("Erreur Test unitaire calcul_distance.\n");
+            exit(-1);
+            }
+
+            //tests unutaires de la fonction calcul_vitesse
+        if (calcul_vitesse(P1,P2)-1613.443 > 0.01){
+             printf ("Erreur Test unitaire calcul_vitesse.\n");
+             exit(-1);
+             }
+
+            //tests unutaires de la fonction distance_a_la_proche_zone
+      if (distance_a_la_proche_zone(P1,zones,nb_zones,&d)!=2){
+             printf ("Erreur Test unitaire distance_a_la_proche_zone.\n");
+             exit(-1);
+             }
+            // Test unitaire de la fonctionGenerique
+      if (fonctionGenerique("4545.0242") - 45.75040333 > 0.0001 )
+            {
+            printf("Erreur Test unitaire conversion latitude !!! \n");
+            exit(-1);
+            }
+        if (fonctionGenerique("00306.6039")- 3.110065 > 0.0001)
+            {
+            printf("Erreur Test unitaire conversion longitude !!! \n");
+            exit(-1);
+            }
+}
+
+
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+  return 0;
+}
Index: tag/rc-1/faye_awasemou/sp4a12/sp4a12/gps.log
===================================================================
--- tag/rc-1/faye_awasemou/sp4a12/sp4a12/gps.log	(nonexistent)
+++ tag/rc-1/faye_awasemou/sp4a12/sp4a12/gps.log	(revision 492)
@@ -0,0 +1,111 @@
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E
+$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C
+$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E
+$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,99.4,T,,M,0.4,N,0.7,K*57
+$GPZDA,141914.00,01,02,2006,00,00*69
+$GPGSV,3,1,10,01,13,142,46,03,48,144,47,11,41,277,,14,27,104,42*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141915.00,A,4545.6423,N,00306.6039,E,0.6,110.2,010206,,*31
+$GPGLL,4545.6423,N,00306.6039,E,141915.00,A*07
+$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,110.2,T,,M,0.6,N,1.2,K*67
+$GPZDA,141915.00,01,02,2006,00,00*68
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,49,28,15,320,*76
+$GPRMC,141916.00,A,4545.6422,N,00306.6037,E,0.1,211.1,010206,,*3B
+$GPGLL,4545.6422,N,00306.6037,E,141916.00,A*0B
+$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,211.1,T,,M,0.1,N,0.2,K*60
+$GPZDA,141916.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,43*78
+$GPGSV,3,2,10,15,03,077,,18,04,041,44,19,85,271,,20,08,214,*7A
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141917.00,A,4545.6422,N,00306.6039,E,0.3,122.3,010206,,*37
+$GPGLL,4545.6422,N,00306.6039,E,141917.00,A*04
+$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,122.3,T,,M,0.3,N,0.5,K*64
+$GPZDA,141917.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,41*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141918.00,A,4545.6421,N,00306.6034,E,0.5,252.2,010206,,*35
+$GPGLL,4545.6421,N,00306.6034,E,141918.00,A*05
+$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,252.2,T,,M,0.5,N,1.0,K*63
+$GPZDA,141918.00,01,02,2006,00,00*65
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,42*79
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141919.00,A,4545.6420,N,00306.6040,E,0.6,95.2,010206,,*0C
+$GPGLL,4545.6420,N,00306.6040,E,141919.00,A*06
+$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,95.2,T,,M,0.6,N,1.2,K*5B
+$GPZDA,141919.00,01,02,2006,00,00*64
+$GPGSV,3,1,10,01,13,142,46,03,48,144,49,11,41,277,,14,27,104,42*7B
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141920.00,A,4545.6419,N,00306.6039,E,0.2,133.1,010206,,*38
+$GPGLL,4545.6419,N,00306.6039,E,141920.00,A*08
+$GPGGA,141920.00,4545.1410,N,00306.6039,E,1,05,3.4,500.0,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,133.1,T,,M,0.2,N,0.4,K*66
+$GPZDA,141920.00,01,02,2006,00,00*6E
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,43*76
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,50,28,15,320,*7F
+$GPRMC,141921.00,A,4545.6419,N,00306.6043,E,0.6,103.1,010206,,*33
+$GPGLL,4545.6419,N,00306.6043,E,141921.00,A*04
+$GPGGA,141921.00,4545.1610,N,00306.6043,E,1,05,3.4,499.8,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,103.1,T,,M,0.6,N,1.1,K*65
+$GPZDA,141921.00,01,02,2006,00,00*6F
+$GPGSV,3,1,10,01,13,142,46,03,48,144,48,11,41,277,,14,27,104,42*7A
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141922.00,A,4545.6418,N,00306.6046,E,0.7,96.9,010206,,*00
+$GPGLL,4545.6418,N,00306.6046,E,141922.00,A*03
+$GPGGA,141922.00,4545.1810,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,96.9,T,,M,0.7,N,1.3,K*53
+$GPZDA,141922.00,01,02,2006,00,00*6C
+$GPGSV,3,1,10,01,13,142,47,03,48,144,46,11,41,277,,14,27,104,43*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141923.00,A,4545.6417,N,00306.6046,E,0.3,113.6,010206,,*39
+$GPGLL,4545.6417,N,00306.6046,E,141923.00,A*0D
+$GPGGA,141923.00,4545.2010,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*7D
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,113.6,T,,M,0.3,N,0.7,K*61
+$GPZDA,141923.00,01,02,2006,00,00*6D
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141924.00,A,4545.6416,N,00306.6044,E,0.2,197.7,010206,,*31
+$GPGLL,4545.6416,N,00306.6044,E,141924.00,A*09
+$GPGGA,141924.00,4545.2210,N,00306.6044,E,1,05,3.4,500.5,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,197.7,T,,M,0.2,N,0.4,K*6E
+$GPZDA,141924.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141925.00,A,4545.6415,N,00306.6046,E,0.2,130.8,010206,,*33
+$GPGLL,4545.6415,N,00306.6046,E,141925.00,A*09
+$GPGGA,141925.00,4545.2410,N,00306.6046,E,1,05,3.4,501.4,M,,M,,*7C
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,130.8,T,,M,0.2,N,0.5,K*6D
+$GPZDA,141925.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,47,28,15,320,*79
+$GPRMC,141926.°E,0.2,260.8,010206,,*34
Index: tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.c
===================================================================
--- tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.c	(nonexistent)
+++ tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.c	(revision 492)
@@ -0,0 +1,28 @@
+/* Fichier trames.c - Gestion et decodage des trames */
+/* Ce fichier sera fourni */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "trame.h"
+
+#define FICHIER_TRAMES "gps.log"  /* Par exemple */
+
+#define MAX_FRAME_LENGTH 80
+
+static char trame_buf[MAX_FRAME_LENGTH];
+static FILE *trame_fic;
+
+int trame_init(void)
+{
+    trame_fic = fopen(FICHIER_TRAMES, "r");
+    if (trame_fic)
+        return 1;
+
+    fprintf(stderr, "Impossible d'ouvrir le fichier %s\n", FICHIER_TRAMES);
+    return 0;
+}
+
+char *trame_suivante(void)
+{
+  return fgets(trame_buf, MAX_FRAME_LENGTH-1, trame_fic);
+}
Index: tag/rc-1/faye_awasemou/sp4a12/sp4a12/sp4a.cbp
===================================================================
--- tag/rc-1/faye_awasemou/sp4a12/sp4a12/sp4a.cbp	(nonexistent)
+++ tag/rc-1/faye_awasemou/sp4a12/sp4a12/sp4a.cbp	(revision 492)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="sp4a" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="sp4a" prefix_auto="1" extension_auto="1" />
+				<Option object_output=".\debug" />
+				<Option type="1" />
+				<Option compiler="gcc" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+		</Compiler>
+		<Unit filename="gps.log" />
+		<Unit filename="main.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.h" />
+		<Extensions>
+			<code_completion />
+			<envvars />
+			<debugger />
+			<lib_finder disable_auto="1" />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
Index: tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.h
===================================================================
--- tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.h	(nonexistent)
+++ tag/rc-1/faye_awasemou/sp4a12/sp4a12/trame.h	(revision 492)
@@ -0,0 +1,3 @@
+
+int trame_init(void);
+char * trame_suivante(void);