Index: branch/CELIK/sp4a12/main.c
===================================================================
--- branch/CELIK/sp4a12/main.c	(revision 493)
+++ branch/CELIK/sp4a12/main.c	(revision 494)
@@ -1,202 +1,249 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <strings.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
 #include "trame.h"
-#include <math.h>
+#include<math.h>
 
-#define pi 3.141592654
+/** definition des constantes **/
+#define rayon_terre 6370
+#define PI 3.14159265
 
-/* Structures */
+/** definition des structures **/
 typedef struct{
-    float Lat; /* latitude */
-    float Lon; /* lontitude */
-} Position;
-
-//Trames de tests à modifier si nécessaire.
-char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
-                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
-                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
-                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
-                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
-                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
-                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
-                    "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
-
-//Fonction à modifier !!!!!
-void traitement(char * trame)
-{
-    static int cpt=0;
-    cpt++;
+    float latitude;
+    float longitude;
+} position;
 
-    if (trame_cmp(trame,"GPGGA") == 1) /* test si les 2 trames sont equivalentes */
-        {
-            printf ("> %s\n", trame); /* affiche uniquement les trames GPGGA */
-        }
-}
+typedef struct{
+    position rpos;
+    float vitmax;
+} zone;
 
+/*Trames de tests ? modifier si n?cessaire.*/ /** tableau des differentes trames **/
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+/** description de toutes les zones **/
+zone zones[]= {
+    {{44.7887762, -3.012}, 50}, /* Descripteur de la premiere zone */
+    {{44.7891220, -3,013}, 70},
+    {{45.7891220, 3,013}, 90},
+};
+
+position pos, pos_prec;
+
 int trame_cmp(char *trame, char *type)
 {
-    int i;
+    int i; /* variable qui permet de parcourir le tableau de caractere trame et type */
     int test=1; /* test=1, si les 2 trames en question sont les memes */
 
-    for (i=0; i<5; i++)
+    for (i=0; i<4; i++) /* on parcourt 4 fois car il y a 4 lettres sur les debuts de trame en prenant pas en compte le caractere $ du debut de trame */
     {
         if (trame[i+1] != type[i]) /* verifie que le debut de la trame correspond au caractere type */
         {
-            test=0;
+            test=0; /* test=0, si les 2 trames sont differentes */
         }
     }
     return test;
 }
-
+
 int decode_int(char c) /* fonction qui permet de passer d'un caractere a un entier */
 {
     int res;
 
-    if ((c>=48) && (c<=58))
+    if ((c>=48) && (c<=58)) /* comparaison si l'argument en entree est compris entre 0 et 9 */
     {
-        res=c-48;
+        res=c-48; /* on soustrait 48 car on veut afficher la bonne valeur */
     }
     else
     {
-        res=-1;
+        res=-1; /* sinon le res vaut -1 s'il n'est pas compris entre 0 et 9 */
     }
     return res;
 }
 
-int decode_nombre(char *ch, int n) /* fonction qui permet de passer d'une chaine de caractere a un entier */
+int decode_nombre(char *ch, int i, int n) /* fonction qui permet de passer d'une chaine de caractere a un entier */
 {
-    int res=0; /* initialisation du resultat=0 */
-    int i;
+    int res=0; /* initialisation de res=0 */
+    int j; /* iteration du tableau de caractere ch */
 
-    for (i=0; i<n; i++)
+    for (j=i; j<i+n; j++) /* parcourt la chaine jusqu'au nombre de caractere souhaite */
     {
-        res=10*res + decode_int(ch[i]); /* permet de reconstituer le nombre terme a terme par puissance de 10 */
+        res=(10*res) + decode_int(ch[j]); /* permet de reconstituer le nombre terme a terme par puissance de 10 */
     }
+
     return res;
 }
 
-float decode_latitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant et son test unitaire */
+float decode_latitude(char *ch) /* fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant */
 {
-    int i;
-    char minute[5]; /*caractere de 4 */
-    float degre_Lat, min_Lat, res_decodeLat;
+    float degres, minute, flottant, res;
 
-    for (i=0; i<4; i++)
-        {
-            minute[i] = trame[i+22];
-        }
+    degres = decode_nombre(ch, 17, 2); /* dans la trame GPGGA, retrouver les degres en sexagesimal */
+    minute = decode_nombre(ch, 19, 2); /* dans la trame GPGGA, retrouver les minutes en sexagesimal */
+    flottant = decode_nombre(ch, 22, 4); /* dans la trame GPGGA, retrouver les secondes (flottant) en sexagesimal */
 
-    degre_Lat = 10*decode_int(trame[17]) + decode_int(trame[18]);
-    min_Lat = 10*decode_int(trame[19]) + decode_int(trame[20]) + 0.0001*decode_nombre(minute,4);
-    res_decodeLat = degre_Lat + min_Lat/60;
+    res = degres + (minute+flottant/10000)/60; /* conversion sexagesimal => degres */
 
-    return res_decodeLat;
+    if (ch[27]=='S') /* identifier dans la trame GPGGA, si la latitude est nord ou bien le sud */
+    {
+        res=-res; /* Si c'est au sud alors inverser les resultats, inversion de polarite */
+    }
+
+    return res;
 }
 
-float decode_longitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant et son test unitaire */
+float decode_longitude(char *ch) /* fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant, meme principe que decode_latitude  */
 {
-    int i;
-    char minute[5];
-    float degre_Lon, min_Lon, res_decodeLon;
+    float degres, minute, flottant, res;
 
-    for (i=0 ; i<4 ; i++)
+    degres = decode_nombre(ch, 29, 3); /* dans la trame GPGGA, retrouver les degres en sexagesimal */
+    minute = decode_nombre(ch, 32, 2); /* dans la trame GPGGA, retrouver les minutes en sexagesimal */
+    flottant = decode_nombre(ch, 35, 4); /* dans la trame GPGGA, retrouver les secondes (flottant) en sexagesimal */
+
+    res = degres + (minute+flottant/10000)/60; /* conversion sexagesimal => degres */
+
+    if (ch[40]=='W') /* identifier dans la trame GPGGA, si la longitude est ouest ou bien est */
     {
-        minute[i] = trame[i+35];
+        res=-res; /* Si c'est ouest alors inverser les resultats, inversion de polarite */
     }
 
-    degre_Lon = 100*decode_int(trame[29]) + 10*decode_int(trame[30]) + decode_int(trame[31]);
-    min_Lon = 10*decode_int(trame[32]) + decode_int(trame[33]) + 0.0001*decode_nombre(minute,4);
-    res_decodeLon = degre_Lon + min_Lon/60;
+    return res;
+}
 
-    return res_decodeLon;
+void decode_trame(char *ch, position *p) /* fonction qui extrait la position (latitude et longitude) pour les trames valides */
+{
+    /* recuperer la latitude ainsi que la longitude de la trame en question */
+    p->latitude = decode_latitude(ch);
+    p->longitude = decode_longitude(ch);
 }
 
-Position decode_position(char *trame) /* fonction qui décode indifféremment une latitude ou une longitude */
+float calcul_distance(position *p1, position *p2)/* fonction qui calcule la distance (en km) entre 2 points reperes par leur latitude et longitude */
 {
-    Position pos;
-    pos.Lat = decode_latitude(trame);
-    pos.Lon = decode_longitude(trame);
+    float res_distance;
+    res_distance = sqrt(pow((p2->latitude-p1->latitude)*PI*rayon_terre/180.0,2)+pow(((p2->longitude-p1->longitude)*(cos(((p2->latitude+p1->latitude)/2.0)*PI/180.0)*PI*rayon_terre/180.0)),2));        /*formule calcul d'une distance sur une sphere */
 
-    return pos;
+    return res_distance;
 }
 
-Position decode_trame(char *trame) /* fonction decode_trame() */
+float calcul_vitesse(position p1, position p2) /* fonction qui calcule la vitesse moyenne (en km/h) entre 2 releves GPS successifs */
 {
-    Position pos;
-    pos.Lat=0;
-    pos.Lon=0;
+    float res_vitesse;
+    res_vitesse = calcul_distance(&p1, &p2)*3600.0;
+    return res_vitesse;
+}
 
-    if (trame_cmp(trame,"GPGGA") == 1)
-    {
-        pos=decode_position(trame);
-    }
+int distance_a_la_plus_proche_zone(position p, zone r[], int nb_zones, float *d) /* fonction qui retourne le numero de la zone dont la distance est la plus proche */
+{
+    float reference;
+    int i, j; /* indice j */
 
-    return pos;
+    reference = calcul_distance(&p, &r[0].rpos); /* recupere la distance entre la position p et la position initiale de la zone dangereuse */
 
+    for (i=0; i<nb_zones; i++) /* parcourt des zones dangereuses */
+        {
+            *d = calcul_distance(&p, &r[i].rpos); /* recalcule la distance de la zone actuelle avec celle de la position */
+
+            if (*d<=reference) /* comparaison entre la distance et la premiere zone dangereuse */
+            {
+                j=i; /* changement de l'indice de la zone la plus proche de la position courante */
+                reference=*d; /* la reference est incremente pour recuperer le numero de la zone dangereuse */
+            }
+        }
+
+    return j;
 }
 
-float calcule_distance (Position p1, Position p2)/* fonction qui calcule la distance (en km) entre 2 points reperes par leur latitude et longitude */
+//Fonction à modifier !!!!!
+void traitement(char * trame)
 {
-    /* variables locales */
-    const float rayon_terre = 6370.0;
-    float x, y, z;
-    float dist;
-    int k=1852;
+    /** initialisation des variables locales **/
+    static int cpt=0;
+    float d;
+    float v;
+    int nbzone, trame_ok;
+    int alarme=0;
+    int seuil_d=100; /* distance max pour que l'alarme soit active */
 
-    x = (p2.Lon-p1.Lon)*cos( ((p1.Lat*pi/180)+(p2.Lat*pi/180))/2.0 );
-    y = p2.Lat-p1.Lat;
-    z = sqrt(pow(x,2)+pow(y,2));
-    dist = k*z;
+    trame_ok=1;
+    cpt++;
 
-    return dist;
+    if (trame_cmp(trame,"GPGGA") == 1) /* test si les 2 trames sont equivalentes */
+        {
+            printf ("> %s\n", trame); /* affiche uniquement les trames GPGGA */
+
+            if (trame_ok==1) /* trame disponible */
+            {
+                trame_ok=0;
+                decode_trame(trame, &pos); /* decoder la trame qui arrive pour obtenir la latitude et longitude */
+
+                if (&pos) /* trame valide donc elle existe */
+                {
+                    v = calcul_vitesse(pos, pos_prec);
+                    nbzone=distance_a_la_plus_proche_zone(pos, zones, sizeof(zone), &d); /*definit la zone la plus proche de la position actuelle */
+
+                    if ( (d<seuil_d) && (v>zones[nbzone].vitmax)) /*verification de la voiture dans une zone proche de la zone et si la vitesse est trop grande pour cette zone*/
+                    {
+                        alarme=1; /* alarme est active ==> ON */
+                    }
+
+                    if(alarme==1)
+                    {
+                        printf("alarme ON\n");
+                    }
+                    else
+                    {
+                        printf("alarme OFF\n");
+                    }
+                    pos_prec=pos; /* la position pos donnee par la trame traitee devient la position pos_prec precedente pour le calcul de vitesse et distance */
+                }
+                printf("Vitesse : %.3f                  Distance : %.3f\n\n", v, d); /* afficher la vitesse et la distance */
+            }
+        }
 }
 
-/* fonction qui calcule la vitesse moyenne (en km/h) entre 2 releves GPS successifs */
-
-//Ajouter vos tests unitaires dans cette fonction.
+//Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void)
-{
+{
     if (5!=5)
-    {
-        printf ("Erreur Test unitaire basique.\n");
-        exit(-1);
+    {
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
     }
-
+
+/** Tests pour voir "GPGGA" en debut de chaine pour la fonction trame_cmp **/
     if (trame_cmp("$GPRMC suite chaine","GPGGA") != 0)
-        {
-            printf ("Erreur Test unitaire trame_cmp.\n");
-            exit(-1);
+        {
+            printf ("Erreur Test unitaire trame_cmp_1\n");
+            exit(-1);
         }
 
     if (trame_cmp("$GPGGA suite chaine","GPGGA") != 1)
-        {
-            printf ("Erreur Test unitaire trame_cmp.\n");
-            exit(-1);
+        {
+            printf ("Erreur Test unitaire trame_cmp_2\n");
+            exit(-1);
         }
 
     if (trame_cmp("$GPRMC suite chaine","GPRMC") != 1)
-        {
-            printf ("Erreur Test unitaire trame_cmp.\n");
-            exit(-1);
+        {
+            printf ("Erreur Test unitaire trame_cmp_3\n");
+            exit(-1);
         }
 
     if (trame_cmp("$APRMC suite chaine","GPGGA") != 0)
-        {
-            printf ("Erreur Test unitaire trame_cmp.\n");
-            exit(-1);
+        {
+            printf ("Erreur Test unitaire trame_cmp_4\n");
+            exit(-1);
         }
-    test_decode_int();
-    test_decode_nombre();
-    test_decode_latitude();
-    test_decode_longitude();
-    test_decode_position();
-    test_decode_trame();
-}
 
-void test_decode_int(void)
-{
+/** test unitaire pour la fonction decode_int **/
     if (decode_int('0') != 0)
     {
         printf ("erreur test unitaire decode_int_10\n");
@@ -259,125 +306,119 @@
 
     if (decode_int('A') != -1)
     {
-        printf ("erreur test unitaire decode_int_2\n");
+        printf ("erreur test unitaire decode_int_20\n");
         exit(-1);
     }
 
     if (decode_int('Z') != -1)
     {
-        printf ("erreur test unitaire decode_int_3\n");
+        printf ("erreur test unitaire decode_int_30\n");
         exit(-1);
     }
-}
 
-void test_decode_nombre()
-{
-    char t[5];
-    t[0] = '1';
-    t[1] = '2';
-    t[2] = '3';
-    t[3] = '4';
-
-    if (decode_nombre(t,1) != 1)
+/** test unitaire pour la fonction decode_nombre **/
+    if (decode_nombre("1234", 0, 2) != 12)
     {
         printf ("Erreur test unitaire decode_nombre_1\n");
         exit(-1);
     }
 
-    if (decode_nombre(t,4) != 1234)
+    if (decode_nombre("6789", 1, 3) != 789)
     {
         printf ("Erreur test unitaire decode_nombre_2\n");
         exit(-1);
     }
-}
 
-void test_decode_latitude()
-{
-    if (decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D") != 45.75)
+/** test unitaire pour la fonction decode_latitude, avec une precision de 10e-3 **/
+    if (((decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-45.75) > 10-3) /* test si la latitude est coherente */
     {
         printf ("Erreur test unitaire decode_latitude\n");
         exit(-1);
     }
-}
 
-void test_decode_longitude()
-{
-    if (decode_longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D") != 3.1100599765777588)
+/** test unitaire pour la fonction decode_longitude, avec une precision de 10e-3 **/
+    if (((decode_longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-3.11006) > 10-3) /* test si la longitude est coherente */
     {
         printf ("Erreur test unitaire decode_longitude\n");
         exit(-1);
     }
-}
 
-void test_decode_position()
-{
-    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lon != 3.1100599765777588)
-    {
-        printf ("Erreur test unitaire decode_longitude-1\n");
-        exit(-1);
-    }
+/** test unitaire pour la fonction decode_trame qui renvoie la latitude et la longitude, avec precision de 10e-3 **/
+    position p1;
+    decode_trame("$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*7A", &p1); /* exemple avec cette trame GPGGA pour la latitude et longitude */
 
-    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 45.75)
+    if ((p1.latitude)-45.750806 > 10-3)
     {
-        printf ("Erreur test unitaire decode_longitude-2\n");
+        printf ("Erreur test unitaire decode_trame coordonnees (latitude)\n");
         exit(-1);
     }
 
-    if (decode_position("$GPGGA,141914.00,4545.0000,N,13000.0000,E,1,05,3.4,499.3,M,,M,,*7D").Lon != 130)
+    if ((p1.longitude)-3.110061 > 10-3)
     {
-        printf ("Erreur test unitaire decode_longitude-3\n");
+        printf ("Erreur test unitaire decode_trame coordonnees (longitude)\n");
         exit(-1);
     }
 
-    if (decode_position("$GPGGA,141914.00,2734.0060,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 27.566766738891602)
-    {
-        printf ("Erreur test unitaire decode_longitude-4\n");
-        exit(-1);
-    }
-}
+/** declaration pts coordonnees de 2 villes pour les tests unitaires de calcul_distance (Paris et Lyon) **/
+    /*Paris*/
+    position p2;
+    p2.latitude = 48.8588897;
+    p2.longitude = 2.320041;
 
-void test_decode_trame()
-{
-    if (decode_trame(trames[0]).Lon != 0)
+    /*Lyon*/
+    position p3;
+    p3.latitude = 45.7578137;
+    p3.longitude = 4.8320114;
+
+    /* test calcul_distance entre Paris et Lyon pour voir si la distance est coherente */
+    if((calcul_distance(&p2,&p3)>392) && (calcul_distance(&p2,&p3)<394))
+    {}
+    else
     {
-        printf ("Erreur test unitaire decode_trame-1\n");
+        printf ("Erreur test unitaire calcul_distance\n");
         exit(-1);
     }
 
-    if (decode_trame(trames[0]).Lat != 0)
+/** declaration 2 points coordonnes aleatoirement (latitude et longitude) pour simuler une différence de position de 1s **/
+    position p4; /* premier point coordonnee */
+    p4.latitude = 45.75040333;
+    p4.longitude = 3.110065;
+
+    position p5; /* second point coordonnee */
+    p5.latitude = 45.7500;
+    p5.longitude = 3.11006;
+
+    if((calcul_vitesse(p4,p5)-1613.443) > 10e-3) /* precision de 10e-3 */
     {
-        printf ("Erreur test unitaire decode_trame-2\n");
+        printf ("Erreur test unitaire calcul_vitesse\n");
         exit(-1);
     }
 
-    if (decode_trame(trames[4]).Lon != 3.1100599765777588)
+    /*test fonction distance_a_la_proche_zone avec l'indice de la zone la plus proche dans le test, la zone 3 correspond a la 4eme zone du tableau zones[]*/
+    float distance = 0.0;
+    int nb_zone = 3; /* variable concernant le test unitaire distance_a_la_plus_proche_zone */
+    if(distance_a_la_plus_proche_zone(p4,zones,nb_zone,&distance) != 2)
     {
-        printf ("Erreur test unitaire decode_trame-3\n");
+        printf ("Erreur test unitaire calcul distance_a_la_plus_proche_zone\n");
         exit(-1);
     }
+}
 
-    if (decode_trame(trames[4]).Lat != 45.75)
-    {
-        printf ("Erreur test unitaire decode_trame-4\n");
-        exit(-1);
-    }
-}
-// Ne pas modifier cette fonction
+/* Ne pas modifier cette fonction*/
 int main(int argc,char ** argv)
 {
     tests_unitaires();
-    // Affichage des trames definies dans la table trames.
+    /* Affichage des trames definies dans la table trames.*/
     printf ("Trames de tests tableau trames:\n");
     int i=0;
     while (trames[i])
         traitement(trames[i++]);
-
     if (!trame_init())
         exit(-1);
-    // Affichage des trames du fichier gps.log
+    /* Affichage des trames du fichier gps.log*/
     char *trame;
     printf ("Trames de tests du fichier gps.log\n");
     while  ((trame = trame_suivante()))
         traitement(trame);
-    return 0;
-}
+    return 0;
+}