Index: tag/rc_1/CELIK/main.c
===================================================================
--- tag/rc_1/CELIK/main.c	(nonexistent)
+++ tag/rc_1/CELIK/main.c	(revision 497)
@@ -0,0 +1,426 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
+#include<math.h>
+
+/** definition des constantes **/
+#define rayon_terre 6370
+#define PI 3.14159265
+
+/** definition des structures **/
+typedef struct{
+    float latitude;
+    float longitude;
+} position;
+
+typedef struct{
+    position rpos;
+    float vitmax;
+} zone;
+
+/*Trames de tests ? modifier si n?cessaire.*/ /** tableau des differentes trames **/
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+/** description de toutes les zones **/
+zone zones[]= {
+    {{44.7887762, -3.012}, 50}, /* Descripteur de la premiere zone */
+    {{44.7891220, -3,013}, 70},
+    {{45.7891220, 3,013}, 90},
+};
+
+position pos, pos_prec;
+
+int trame_cmp(char *trame, char *type)
+{
+    int i; /* variable qui permet de parcourir le tableau de caractere trame et type */
+    int test=1; /* test=1, si les 2 trames en question sont les memes */
+
+    for (i=0; i<4; i++) /* on parcourt 4 fois car il y a 4 lettres sur les debuts de trame en prenant pas en compte le caractere $ du debut de trame */
+    {
+        if (trame[i+1] != type[i]) /* verifie que le debut de la trame correspond au caractere type */
+        {
+            test=0; /* test=0, si les 2 trames sont differentes */
+        }
+    }
+    return test;
+}
+
+int decode_int(char c) /* fonction qui permet de passer d'un caractere a un entier */
+{
+    int res;
+
+    if ((c>=48) && (c<=58)) /* comparaison si l'argument en entree est compris entre 0 et 9 */
+    {
+        res=c-48; /* on soustrait 48 car on veut afficher la bonne valeur */
+    }
+    else
+    {
+        res=-1; /* sinon le res vaut -1 s'il n'est pas compris entre 0 et 9 */
+    }
+    return res;
+}
+
+int decode_nombre(char *ch, int i, int n) /* fonction qui permet de passer d'une chaine de caractere a un entier */
+{
+    int res=0; /* initialisation de res=0 */
+    int j; /* iteration du tableau de caractere ch */
+
+    for (j=i; j<i+n; j++) /* parcourt la chaine jusqu'au nombre de caractere souhaite */
+    {
+        res=(10*res) + decode_int(ch[j]); /* permet de reconstituer le nombre terme a terme par puissance de 10 */
+    }
+
+    return res;
+}
+
+float decode_latitude(char *ch) /* fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant */
+{
+    float degres, minute, flottant, res;
+
+    degres = decode_nombre(ch, 17, 2); /* dans la trame GPGGA, retrouver les degres en sexagesimal */
+    minute = decode_nombre(ch, 19, 2); /* dans la trame GPGGA, retrouver les minutes en sexagesimal */
+    flottant = decode_nombre(ch, 22, 4); /* dans la trame GPGGA, retrouver les secondes (flottant) en sexagesimal */
+
+    res = degres + (minute+flottant/10000)/60; /* conversion sexagesimal => degres */
+
+    if (ch[27]=='S') /* identifier dans la trame GPGGA, si la latitude est nord ou bien le sud */
+    {
+        res=-res; /* Si c'est au sud alors inverser les resultats, inversion de polarite */
+    }
+
+    return res;
+}
+
+float decode_longitude(char *ch) /* fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant, meme principe que decode_latitude  */
+{
+    float degres, minute, flottant, res;
+
+    degres = decode_nombre(ch, 29, 3); /* dans la trame GPGGA, retrouver les degres en sexagesimal */
+    minute = decode_nombre(ch, 32, 2); /* dans la trame GPGGA, retrouver les minutes en sexagesimal */
+    flottant = decode_nombre(ch, 35, 4); /* dans la trame GPGGA, retrouver les secondes (flottant) en sexagesimal */
+
+    res = degres + (minute+flottant/10000)/60; /* conversion sexagesimal => degres */
+
+    if (ch[40]=='W') /* identifier dans la trame GPGGA, si la longitude est ouest ou bien est */
+    {
+        res=-res; /* Si c'est ouest alors inverser les resultats, inversion de polarite */
+    }
+
+    return res;
+}
+
+void decode_trame(char *ch, position *p) /* fonction qui extrait la position (latitude et longitude) pour les trames valides */
+{
+    /* recuperer la latitude ainsi que la longitude de la trame en question */
+    p->latitude = decode_latitude(ch);
+    p->longitude = decode_longitude(ch);
+}
+
+float calcul_distance(position *p1, position *p2)/* fonction qui calcule la distance (en km) entre 2 points reperes par leur latitude et longitude */
+{
+    float res_distance;
+
+    /* formule de calcul d'une distance sur une sphere, d'apres les recherches sur internet */
+    res_distance = sqrt(pow((p2->latitude-p1->latitude)*PI*rayon_terre/180.0,2)+pow(((p2->longitude-p1->longitude)*(cos(((p2->latitude+p1->latitude)/2.0)*PI/180.0)*PI*rayon_terre/180.0)),2));
+
+    return res_distance;
+}
+
+float calcul_vitesse(position p1, position p2) /* fonction qui calcule la vitesse moyenne (en km/h) entre 2 releves GPS successifs */
+{
+    float res_vitesse;
+    res_vitesse = calcul_distance(&p1, &p2)*3600.0; /* v=d/t sachant que le tps est de 1s on a donc la vitesse en km/s, soit x3600 pour l'avoir en km/h */
+    return res_vitesse;
+}
+
+int distance_a_la_plus_proche_zone(position p, zone r[], int nb_zones, float *d) /* fonction qui retourne le numero de la zone dont la distance est la plus proche */
+{
+    float reference;
+    int i, j; /* indice j */
+
+    reference = calcul_distance(&p, &r[0].rpos); /* recupere la distance entre la position p et la position initiale de la zone dangereuse */
+
+    for (i=0; i<nb_zones; i++) /* parcourt des zones dangereuses */
+        {
+            *d = calcul_distance(&p, &r[i].rpos); /* recalcule la distance de la zone actuelle avec celle de la position */
+
+            if (*d<=reference) /* comparaison entre la distance et la premiere zone dangereuse */
+            {
+                j=i; /* changement de l'indice de la zone la plus proche de la position courante */
+                reference=*d; /* la reference est incremente pour recuperer le numero de la zone dangereuse */
+            }
+        }
+
+    return j;
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    /** initialisation des variables locales **/
+    static int cpt=0;
+    float d;
+    float v;
+    int nbzone, trame_ok;
+    int alarme=0;
+    int seuil_d=100; /* distance max pour que l'alarme soit active */
+
+    trame_ok=1;
+    cpt++;
+
+    if (trame_cmp(trame,"GPGGA") == 1) /* test si les 2 trames sont equivalentes */
+        {
+            printf ("> %s\n", trame); /* affiche uniquement les trames GPGGA */
+
+            if (trame_ok==1) /* trame disponible */
+            {
+                trame_ok=0;
+                decode_trame(trame, &pos); /* decoder la trame qui arrive pour obtenir la latitude et longitude */
+
+                if (&pos) /* trame valide donc elle existe */
+                {
+                    v = calcul_vitesse(pos, pos_prec); /* calcule la vitesse entre la position de la voiture */
+                    nbzone=distance_a_la_plus_proche_zone(pos, zones, sizeof(zone), &d); /*definit la zone la plus proche de la position actuelle */
+
+                    if ( (d<seuil_d) && (v>zones[nbzone].vitmax)) /*verification de la voiture dans une zone proche de la zone et si la vitesse est trop grande pour cette zone*/
+                    {
+                        alarme=1; /* alarme est active ==> ON */
+                    }
+
+                    if(alarme==1)
+                    {
+                        printf("alarme ON\n");
+                    }
+                    else
+                    {
+                        printf("alarme OFF\n");
+                    }
+                    pos_prec=pos; /* la position pos donnee par la trame traitee devient la position pos_prec precedente pour le calcul de vitesse et distance */
+                }
+                printf("Vitesse : %.3f                  Distance : %.3f\n\n", v, d); /* afficher la vitesse et la distance */
+            }
+        }
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void)
+{
+    if (5!=5)
+    {
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+
+/** Tests pour voir "GPGGA" en debut de chaine pour la fonction trame_cmp **/
+    if (trame_cmp("$GPRMC suite chaine","GPGGA") != 0)
+        {
+            printf ("Erreur Test unitaire trame_cmp_1\n");
+            exit(-1);
+        }
+
+    if (trame_cmp("$GPGGA suite chaine","GPGGA") != 1)
+        {
+            printf ("Erreur Test unitaire trame_cmp_2\n");
+            exit(-1);
+        }
+
+    if (trame_cmp("$GPRMC suite chaine","GPRMC") != 1)
+        {
+            printf ("Erreur Test unitaire trame_cmp_3\n");
+            exit(-1);
+        }
+
+    if (trame_cmp("$APRMC suite chaine","GPGGA") != 0)
+        {
+            printf ("Erreur Test unitaire trame_cmp_4\n");
+            exit(-1);
+        }
+
+/** test unitaire pour la fonction decode_int **/
+    if (decode_int('0') != 0)
+    {
+        printf ("erreur test unitaire decode_int_10\n");
+        exit(-1);
+    }
+
+    if (decode_int('1') != 1)
+    {
+        printf ("erreur test unitaire decode_int_11\n");
+        exit(-1);
+    }
+
+    if (decode_int('2') != 2)
+    {
+        printf ("erreur test unitaire decode_int_12\n");
+        exit(-1);
+    }
+
+    if (decode_int('3') != 3)
+    {
+        printf ("erreur test unitaire decode_int_13\n");
+        exit(-1);
+    }
+
+    if (decode_int('4') != 4)
+    {
+        printf ("erreur test unitaire decode_int_14\n");
+        exit(-1);
+    }
+
+    if (decode_int('5') != 5)
+    {
+        printf ("erreur test unitaire decode_int_15\n");
+        exit(-1);
+    }
+
+    if (decode_int('6') != 6)
+    {
+        printf ("erreur test unitaire decode_int_16\n");
+        exit(-1);
+    }
+
+    if (decode_int('7') != 7)
+    {
+        printf ("erreur test unitaire decode_int_17\n");
+        exit(-1);
+    }
+
+    if (decode_int('8') != 8)
+    {
+        printf ("erreur test unitaire decode_int_18\n");
+        exit(-1);
+    }
+
+    if (decode_int('9') != 9)
+    {
+        printf ("erreur test unitaire decode_int_19\n");
+        exit(-1);
+    }
+
+    if (decode_int('A') != -1)
+    {
+        printf ("erreur test unitaire decode_int_20\n");
+        exit(-1);
+    }
+
+    if (decode_int('Z') != -1)
+    {
+        printf ("erreur test unitaire decode_int_30\n");
+        exit(-1);
+    }
+
+/** test unitaire pour la fonction decode_nombre **/
+    if (decode_nombre("1234", 0, 2) != 12)
+    {
+        printf ("Erreur test unitaire decode_nombre_1\n");
+        exit(-1);
+    }
+
+    if (decode_nombre("6789", 1, 3) != 789)
+    {
+        printf ("Erreur test unitaire decode_nombre_2\n");
+        exit(-1);
+    }
+
+/** test unitaire pour la fonction decode_latitude, avec une precision de 10e-3 **/
+    if (((decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-45.75) > 10-3) /* test si la latitude est coherente */
+    {
+        printf ("Erreur test unitaire decode_latitude\n");
+        exit(-1);
+    }
+
+/** test unitaire pour la fonction decode_longitude, avec une precision de 10e-3 **/
+    if (((decode_longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-3.11006) > 10-3) /* test si la longitude est coherente */
+    {
+        printf ("Erreur test unitaire decode_longitude\n");
+        exit(-1);
+    }
+
+/** test unitaire pour la fonction decode_trame qui renvoie la latitude et la longitude, avec precision de 10e-3 **/
+    position p1;
+    decode_trame("$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*7A", &p1); /* exemple avec cette trame GPGGA pour la latitude et longitude */
+
+    if ((p1.latitude)-45.750806 > 10-3)
+    {
+        printf ("Erreur test unitaire decode_trame coordonnees (latitude)\n");
+        exit(-1);
+    }
+
+    if ((p1.longitude)-3.110061 > 10-3)
+    {
+        printf ("Erreur test unitaire decode_trame coordonnees (longitude)\n");
+        exit(-1);
+    }
+
+/** declaration pts coordonnees de 2 villes pour les tests unitaires de calcul_distance (Paris et Lyon) **/
+    /*Paris*/
+    position p2;
+    p2.latitude = 48.8588897;
+    p2.longitude = 2.320041;
+
+    /*Lyon*/
+    position p3;
+    p3.latitude = 45.7578137;
+    p3.longitude = 4.8320114;
+
+    /* test calcul_distance entre Paris et Lyon pour voir si la distance est coherente */
+    if((calcul_distance(&p2,&p3)>392) && (calcul_distance(&p2,&p3)<394))
+    {}
+    else
+    {
+        printf ("Erreur test unitaire calcul_distance\n");
+        exit(-1);
+    }
+
+/** declaration 2 points coordonnes aleatoirement (latitude et longitude) pour simuler une différence de position de 1s **/
+    position p4; /* premier point coordonnee */
+    p4.latitude = 45.75040333;
+    p4.longitude = 3.110065;
+
+    position p5; /* second point coordonnee */
+    p5.latitude = 45.7500;
+    p5.longitude = 3.11006;
+
+    if((calcul_vitesse(p4,p5)-1613.443) > 10e-3) /* precision de 10e-3 */
+    {
+        printf ("Erreur test unitaire calcul_vitesse\n");
+        exit(-1);
+    }
+
+    /*test fonction distance_a_la_proche_zone avec l'indice de la zone la plus proche dans le test, la zone 3 correspond a la 4eme zone du tableau zones[]*/
+    float distance = 0.0;
+    int nb_zone = 3; /* variable concernant le test unitaire distance_a_la_plus_proche_zone */
+    if(distance_a_la_plus_proche_zone(p4,zones,nb_zone,&distance) != 2)
+    {
+        printf ("Erreur test unitaire calcul distance_a_la_plus_proche_zone\n");
+        exit(-1);
+    }
+}
+
+/* Ne pas modifier cette fonction*/
+int main(int argc,char ** argv)
+{
+    tests_unitaires();
+    /* Affichage des trames definies dans la table trames.*/
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+    if (!trame_init())
+        exit(-1);
+    /* Affichage des trames du fichier gps.log*/
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+    return 0;
+}
Index: tag/rc_1/CELIK/gps.log
===================================================================
--- tag/rc_1/CELIK/gps.log	(nonexistent)
+++ tag/rc_1/CELIK/gps.log	(revision 497)
@@ -0,0 +1,111 @@
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E
+$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C
+$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E
+$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,99.4,T,,M,0.4,N,0.7,K*57
+$GPZDA,141914.00,01,02,2006,00,00*69
+$GPGSV,3,1,10,01,13,142,46,03,48,144,47,11,41,277,,14,27,104,42*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141915.00,A,4545.6423,N,00306.6039,E,0.6,110.2,010206,,*31
+$GPGLL,4545.6423,N,00306.6039,E,141915.00,A*07
+$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,110.2,T,,M,0.6,N,1.2,K*67
+$GPZDA,141915.00,01,02,2006,00,00*68
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,49,28,15,320,*76
+$GPRMC,141916.00,A,4545.6422,N,00306.6037,E,0.1,211.1,010206,,*3B
+$GPGLL,4545.6422,N,00306.6037,E,141916.00,A*0B
+$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,211.1,T,,M,0.1,N,0.2,K*60
+$GPZDA,141916.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,43*78
+$GPGSV,3,2,10,15,03,077,,18,04,041,44,19,85,271,,20,08,214,*7A
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141917.00,A,4545.6422,N,00306.6039,E,0.3,122.3,010206,,*37
+$GPGLL,4545.6422,N,00306.6039,E,141917.00,A*04
+$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,122.3,T,,M,0.3,N,0.5,K*64
+$GPZDA,141917.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,41*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141918.00,A,4545.6421,N,00306.6034,E,0.5,252.2,010206,,*35
+$GPGLL,4545.6421,N,00306.6034,E,141918.00,A*05
+$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,252.2,T,,M,0.5,N,1.0,K*63
+$GPZDA,141918.00,01,02,2006,00,00*65
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,42*79
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141919.00,A,4545.6420,N,00306.6040,E,0.6,95.2,010206,,*0C
+$GPGLL,4545.6420,N,00306.6040,E,141919.00,A*06
+$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,95.2,T,,M,0.6,N,1.2,K*5B
+$GPZDA,141919.00,01,02,2006,00,00*64
+$GPGSV,3,1,10,01,13,142,46,03,48,144,49,11,41,277,,14,27,104,42*7B
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141920.00,A,4545.6419,N,00306.6039,E,0.2,133.1,010206,,*38
+$GPGLL,4545.6419,N,00306.6039,E,141920.00,A*08
+$GPGGA,141920.00,4545.1410,N,00306.6039,E,1,05,3.4,500.0,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,133.1,T,,M,0.2,N,0.4,K*66
+$GPZDA,141920.00,01,02,2006,00,00*6E
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,43*76
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,50,28,15,320,*7F
+$GPRMC,141921.00,A,4545.6419,N,00306.6043,E,0.6,103.1,010206,,*33
+$GPGLL,4545.6419,N,00306.6043,E,141921.00,A*04
+$GPGGA,141921.00,4545.1610,N,00306.6043,E,1,05,3.4,499.8,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,103.1,T,,M,0.6,N,1.1,K*65
+$GPZDA,141921.00,01,02,2006,00,00*6F
+$GPGSV,3,1,10,01,13,142,46,03,48,144,48,11,41,277,,14,27,104,42*7A
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141922.00,A,4545.6418,N,00306.6046,E,0.7,96.9,010206,,*00
+$GPGLL,4545.6418,N,00306.6046,E,141922.00,A*03
+$GPGGA,141922.00,4545.1810,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,96.9,T,,M,0.7,N,1.3,K*53
+$GPZDA,141922.00,01,02,2006,00,00*6C
+$GPGSV,3,1,10,01,13,142,47,03,48,144,46,11,41,277,,14,27,104,43*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141923.00,A,4545.6417,N,00306.6046,E,0.3,113.6,010206,,*39
+$GPGLL,4545.6417,N,00306.6046,E,141923.00,A*0D
+$GPGGA,141923.00,4545.2010,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*7D
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,113.6,T,,M,0.3,N,0.7,K*61
+$GPZDA,141923.00,01,02,2006,00,00*6D
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141924.00,A,4545.6416,N,00306.6044,E,0.2,197.7,010206,,*31
+$GPGLL,4545.6416,N,00306.6044,E,141924.00,A*09
+$GPGGA,141924.00,4545.2210,N,00306.6044,E,1,05,3.4,500.5,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,197.7,T,,M,0.2,N,0.4,K*6E
+$GPZDA,141924.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141925.00,A,4545.6415,N,00306.6046,E,0.2,130.8,010206,,*33
+$GPGLL,4545.6415,N,00306.6046,E,141925.00,A*09
+$GPGGA,141925.00,4545.2410,N,00306.6046,E,1,05,3.4,501.4,M,,M,,*7C
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,130.8,T,,M,0.2,N,0.5,K*6D
+$GPZDA,141925.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,47,28,15,320,*79
+$GPRMC,141926.°E,0.2,260.8,010206,,*34
Index: tag/rc_1/CELIK/trame.c
===================================================================
--- tag/rc_1/CELIK/trame.c	(nonexistent)
+++ tag/rc_1/CELIK/trame.c	(revision 497)
@@ -0,0 +1,28 @@
+/* Fichier trames.c - Gestion et decodage des trames */
+/* Ce fichier sera fourni */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "trame.h"
+
+#define FICHIER_TRAMES "gps.log"  /* Par exemple */
+
+#define MAX_FRAME_LENGTH 80
+
+static char trame_buf[MAX_FRAME_LENGTH];
+static FILE *trame_fic;
+
+int trame_init(void)
+{
+    trame_fic = fopen(FICHIER_TRAMES, "r");
+    if (trame_fic)
+        return 1;
+
+    fprintf(stderr, "Impossible d'ouvrir le fichier %s\n", FICHIER_TRAMES);
+    return 0;
+}
+
+char *trame_suivante(void)
+{
+  return fgets(trame_buf, MAX_FRAME_LENGTH-1, trame_fic);
+}
Index: tag/rc_1/CELIK/sp4a.cbp
===================================================================
--- tag/rc_1/CELIK/sp4a.cbp	(nonexistent)
+++ tag/rc_1/CELIK/sp4a.cbp	(revision 497)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="sp4a" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="sp4a" prefix_auto="1" extension_auto="1" />
+				<Option object_output=".\debug" />
+				<Option type="1" />
+				<Option compiler="gcc" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+		</Compiler>
+		<Unit filename="gps.log" />
+		<Unit filename="main.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.h" />
+		<Extensions>
+			<code_completion />
+			<envvars />
+			<debugger />
+			<lib_finder disable_auto="1" />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
Index: tag/rc_1/CELIK/trame.h
===================================================================
--- tag/rc_1/CELIK/trame.h	(nonexistent)
+++ tag/rc_1/CELIK/trame.h	(revision 497)
@@ -0,0 +1,3 @@
+
+int trame_init(void);
+char * trame_suivante(void);